using System.Text.Json.Serialization;

namespace LuskiServer.Classes;

public class AppConfig
{
    [JsonInclude]
    [JsonPropertyName("addresses")]
    public string[] Addresses { get; set; } = new string[]{"http://localhost"};
    [JsonInclude]
    [JsonPropertyName("address")]
    public string Address { get; set; } = "127.0.0.1";
    [JsonInclude]
    [JsonPropertyName("data_id")]
    public byte DataId { get; set; } = 0;
    [JsonInclude]
    [JsonPropertyName("server_epoch")]
    public DateTime ServerEpoch { get; set; } = DateTime.UtcNow.Date;
    [JsonInclude]
    [JsonPropertyName("database")]
    public string Database { get; set; } = "Some database name";
    [JsonInclude]
    [JsonPropertyName("username")]
    public string Username { get; set; } = "Some postgresql username";
    [JsonInclude]
    [JsonPropertyName("password")]
    public string Password { get; set; } = "Some postgresql password";
    [JsonInclude]
    [JsonPropertyName("connection_name")]
    public string CustomeName { get; set; } = "Luski Server";
    [JsonInclude]
    [JsonPropertyName("wss_ipv4")]
    public string IPv4WSS { get; set; } = "127.0.0.1";
    [JsonInclude]
    [JsonPropertyName("wss_ipv4_URL")]
    public string? IPv4_URL_WSS { get; set; } = "";
    [JsonInclude]
    [JsonPropertyName("wss_ipv4_overide")]
    public string? IPv4_Overode_WSS { get; set; } = null;
    [JsonInclude]
    [JsonPropertyName("wss_ipv4_port")]
    public int IPv4PortWSS { get; set; } = 80;
    [JsonInclude]
    [JsonPropertyName("wss_ipv4_secure")]
    public bool IPv4SecureWSS { get; set; } = true;
    [JsonInclude]
    [JsonPropertyName("wss_ipv6")]
    public string? IPv6WSS { get; set; } = null;
    [JsonInclude]
    [JsonPropertyName("wss_ipv6_URL")]
    public string? IPv6_URL_WSS { get; set; } = "";
    [JsonInclude]
    [JsonPropertyName("wss_ipv6_port")]
    public int IPv6PortWSS { get; set; } = 0;
    [JsonInclude]
    [JsonPropertyName("wss_ipv6_secure")]
    public bool IPv6SecureWSS { get; set; } = true;
}

[JsonSerializable(typeof(AppConfig))]
[JsonSourceGenerationOptions(WriteIndented = true, DefaultIgnoreCondition = JsonIgnoreCondition.Never, GenerationMode = JsonSourceGenerationMode.Default)]
internal partial class AppConfigContext : JsonSerializerContext
{

}