using System.Text.Json.Serialization;
using JacobTechEncryption.Enums;
using Luski.Shared.PublicServers.V1.ServerToClient.HTTP;
using LuskiServer.Interfaces.ServerComs;

namespace LuskiServer.Classes.ServerComs;

public class MessageEvent : IServerEvent
{
    [JsonInclude]
    [JsonPropertyName("author_id")]
    public long UserID { get; set; }
    [JsonInclude]
    [JsonPropertyName("channel_id")]
    public long ChannelID { get; set; }
    [JsonInclude]
    [JsonPropertyName("context")]
    public string Base64Context { get; set; }
    [JsonInclude]
    [JsonPropertyName("id")]
    public long ID { get; set; }
    [JsonInclude]
    [JsonPropertyName("files")]
    public ServerFileInfoSTC[] Files { get; set; }
    
    [JsonInclude]
    [JsonPropertyName("encryption_key")]
    public long EncryptionKey { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("encoder_type")]
    public EncoderType EncoderType { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("is_channel_profile")]
    public bool IsProfile { get; set; }
}

[JsonSerializable(typeof(MessageEvent))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
internal partial class MessageEventContext : JsonSerializerContext
{

}