using System.Text.Json.Serialization;
using LuskiServer.Enums.ServerComs;
using LuskiServer.Interfaces.ServerComs;

namespace LuskiServer.Classes.ServerComs;

public class ServerEvent
{
    [JsonInclude]
    [JsonPropertyName("type")]
    public DataType Type { get; set; }
    
    [JsonInclude]
    [JsonPropertyName("data")]
    public object Data { get; set; }
}

[JsonSerializable(typeof(ServerEvent))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
internal partial class ServerEventContext : JsonSerializerContext
{

}