using Luski.Shared.PublicServers.V1.Enums;
using ServerDatabase;
using ServerDatabase.SourceGenerator;
using bob = Luski.Shared.PublicServers.V1.Enums.PictureType;

namespace LuskiServer.Classes.TableDef;

public class ChannelProfiles
{
    public static TableColumn<long> ID { get; } = new("id", true);
    public static TableColumn<string> DisplayName { get; } = new("displayname");
    public static TableColumn<long[]> Controllers { get; } = new("controllers") {DefaultValue = Array.Empty<long>()};
    public static TableColumn<PictureType> PictureType { get; } = new("picture_type") {DefaultValue = bob.png };
    public static TableColumn<byte[]> Picture { get; } = new("picture");
    public static TableColumn<byte[]> Color { get; } = new("color") { DefaultValue = new byte[]{255,255,255,255}};
}

[TableRow(typeof(ChannelProfiles))]
public partial class ChannelProfileRow
{}