using JacobTechEncryption.Enums;
using ServerDatabase;
using ServerDatabase.SourceGenerator;

namespace LuskiServer.Classes.TableDef;

public static class Files
{
    public static TableColumn<long> ID { get; } = new("id", true);
    public static TableColumn<long> Owner { get; } = new("owner");
    public static TableColumn<bool> Public { get; } = new("public_download");
    public static TableColumn<long[]> AllowedChannels { get; } = new("channels");
    public static TableColumn<long> Size { get; } = new("size");
    public static TableColumn<byte[]> Name { get; } = new("name");
    public static TableColumn<byte[]> Hash { get; } = new("hash");
    public static TableColumn<byte[]> Data { get; } = new("data");
    public static TableColumn<long> EncryptionKey { get; } = new("encryption_key");
    public static TableColumn<EncoderType> EncoderType { get; } = new("encoder_type");
    public static TableColumn<long> NameEncryptionKey { get; } = new("name_encryption_key");
    public static TableColumn<EncoderType> NameEncoderType { get; } = new("name_encoder_type");
}

[TableRow(typeof(Files))]
public partial class FileRow
{
}