using Luski.Shared.PublicServers.V1.Enums;
using LuskiServer.Enums;
using ServerDatabase;
using ServerDatabase.SourceGenerator;

namespace LuskiServer.Classes.TableDef;

public static class Roles
{
    public static TableColumn<long> ID { get; } = new("id", true);
    public static TableColumn<string> Name { get; } = new("name");
    public static TableColumn<string> DisplayName { get; } = new("display_name") {DefaultValue = string.Empty};
    public static TableColumn<int> Index { get; } = new("index") {DefaultValue = 0 };
    public static TableColumn<byte[]> Color { get; } = new("color") {DefaultValue = new byte[]{255,255,255,255}};
    public static TableColumn<string> Description { get; } = new("description");
    public static TableColumn<ServerPermission> ServerPermissions { get; } = new("server_perms");
    public static TableColumn<long[]> MembersList { get; } = new("members_list") {DefaultValue = Array.Empty<long>()};
}

[TableRow(typeof(Roles))]
public partial class RoleRow
{}