using Luski.Shared.PublicServers.V1.Enums;
using LuskiServer.Enums;
using ServerDatabase;
using ServerDatabase.SourceGenerator;
using bob = Luski.Shared.PublicServers.V1.Enums.PictureType;


namespace LuskiServer.Classes.TableDef;

public static class Server
{
    public static TableColumn<long> ID { get; } = new("id", true) { DefaultValue = 0 };
    public static TableColumn<PictureType> PictureType { get; } = new("picture_type") {DefaultValue = bob.png };
    public static TableColumn<byte[]> Picture { get; } = new("picture") { DefaultValue = Array.Empty<byte>() };
    public static TableColumn<string> Name { get; } = new("name") { DefaultValue = "Luski Server" };
    public static TableColumn<string> Description { get; } = new("description") { DefaultValue = "description" };
    public static TableColumn<long> Owner { get; } = new("owner") { DefaultValue = -1 };
}

[TableRow(typeof(Server))]
public partial class ServerRow
{}