using ServerDatabase;
using ServerDatabase.SourceGenerator;
using ServerDatabase.Utils;
using ServerDatabase.Utils.Enums;

namespace LuskiServer.Classes.TableDef;

public static class Sessions
{
    public static TableColumn<long> ID { get; } = new("id", true);
    public static TableColumn<long> User { get; } = new("userid") 
        {ForeignKeys = new IForeignKey[]{ new ForeignKey(){Table = Tables.Users, Column = Users.ID}}};
    public static TableColumn<string> WSSTCP { get; } = new("wsstcp");
    public static TableColumn<string> Token { get; } = new("token");
    public static TableColumn<string> LoginToken { get; } = new("login_token");
    public static TableColumn<long> SessionKey { get; } = new("session_key")
        {ForeignKeys = new IForeignKey[]{ new ForeignKey(){Table = Tables.Keys, Column = Keys.ID, OnDelete = ConstraintAction.Cascade}}};

    public static TableColumn<long> StorageID { get; } = new("storage_id");
}

[TableRow(typeof(Sessions))]
public partial class SessionsRow
{}
