using System.Text.Json.Serialization;

namespace LuskiServer.Converters.Matrix.Types;

public class Message
{
    [JsonInclude]
    [JsonPropertyName("content")]
    public MessageContext Context { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("origin_server_ts")]
    public long Origin { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("room_id")]
    public string Room { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("sender")]
    public string Sender { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("state_key")]
    public string State { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("type")]
    public string Type { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("event_id")]
    public string Event { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("user_id")]
    public string Author { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("age")]
    public long TimeStamp { get; set; } = default!;

    [JsonInclude]
    [JsonPropertyName("unsigned")]
    public Unsigned Unsigned { get; set; } = default!;
   
}

[JsonSerializable(typeof(Message))]
[JsonSourceGenerationOptions(WriteIndented = true, DefaultIgnoreCondition = JsonIgnoreCondition.Never, GenerationMode = JsonSourceGenerationMode.Default)]
internal partial class MessageJsonContext : JsonSerializerContext
{

}