using System.Text.Json.Serialization;

namespace LuskiServer.Converters.Matrix.Types;

public class MessageExport
{
    [JsonInclude]
    [JsonPropertyName("room_name")]
    public string RoomName { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("room_creator")]
    public string RoomOwner { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("topic")]
    public string RoomTopic { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("export_date")]
    public string ExportDate { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("exported_by")]
    public string Exporter { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("messages")]
    public Message[] Messages { get; set; } = default!;
}

[JsonSerializable(typeof(MessageExport))]
[JsonSourceGenerationOptions(WriteIndented = true, DefaultIgnoreCondition = JsonIgnoreCondition.Never, GenerationMode = JsonSourceGenerationMode.Default)]
internal partial class MessageExportContext : JsonSerializerContext
{

}