using System.Reflection;
using System.Text;
using Asp.Versioning.ApiExplorer;
using JacobTechEncryption.Enums;
using Luski.Shared.PublicServers.V1.Enums;
using Luski.Shared.PublicServers.V1.ServerToClient.HTTP;
using LuskiServer;
using LuskiServer.Classes;
using LuskiServer.Classes.ServerComs;
using LuskiServer.Classes.TableDef;
using LuskiServer.Converters.Matrix.Types;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Options;
using ServerDatabase;
using ServerDatabase.Utils;
using Swashbuckle.AspNetCore.SwaggerGen;

[assembly: Microsoft.AspNetCore.Mvc.ApiController]

LuskiFunctions.Config = LuskiServer.Classes.LuskiFunctions.GetSettings("/etc/luskiserver/app.json", AppConfigContext.Default.AppConfig, true);
List<string> tttt = args.ToList();
if (tttt.Contains("--urls"))
{
    tttt[tttt.IndexOf("--urls") + 1] = string.Join(";", LuskiFunctions.Config.Addresses);
}
else
{
    tttt.Add("--urls");
    tttt.Add(string.Join(";", LuskiFunctions.Config.Addresses));
}

args = tttt.ToArray();
Console.WriteLine($"Server starting with starting epoch of {LuskiFunctions.Config.ServerEpoch.ToLocalTime()} and current time of {DateTime.UtcNow.ToLocalTime()}");
LuskiFunctions.Database = new Database(LuskiFunctions.Config.Address, 
    LuskiFunctions.Config.Database, 
    LuskiFunctions.Config.Username, 
    LuskiFunctions.Config.Password,
    LuskiFunctions.Config.CustomeName);


Dictionary<string, List<Message>> fff = new();


try
{
    LuskiFunctions.Database.ExecuteNonQuery($"CREATE DATABASE {LuskiFunctions.Config.Database} WITH OWNER = {LuskiFunctions.Config.Username} ENCODING = 'UTF8' CONNECTION LIMIT = -1 IS_TEMPLATE = False;");
    Console.WriteLine("Database Created");
}
catch
{
    Console.WriteLine("Database Found");
}

foreach (PropertyInfo prop in typeof(Tables).GetProperties())
{
    IBetterTable table = (IBetterTable)prop.GetValue(null)!;
    table.DatabaseHandler = LuskiFunctions.Database;
    Type t = Type.GetType($"LuskiServer.Classes.TableDef.{prop.Name}")!;
    foreach(PropertyInfo prop2 in t.GetProperties())
    {
        table.AddColumn((ITableColumn)prop2.GetValue(null)!, prop2.Name);
    }
    LuskiFunctions.Database.Tables.Add(table);
}

LuskiFunctions.Database.RegisterTables();

bool d = Tables.Storage.TryReadRow(out StorageRow row, Storage.ID.CreateParameter(534144618594309));
Console.WriteLine(d);
//Tables.Channels.Update(Channels.ID, 0, Channels.PictureType.CreateParameter(PictureType.png), Channels.Picture.CreateParameter(File.ReadAllBytes("/home/jacob/Pictures/Logo.png")));
/*
Dictionary<string, long> AMap = new()
{
    {"@jacobtech:matrix.org", 0}
};

Dictionary<string, int> BMap = new()
{
    {"@rqndomnezz:matrix.org",0},
    {"@ardillybar:matrix.org", 1},
    {"@themagicalcats:matrix.org", 2},
    {"@c4tz:matrix.org", 2},
    {"@jobotnik:matrix.org", 3},
    {"@captainleader:matrix.org", 4},
    {"@kaizenash:matrix.org", 4},
    {"@bubs_cooper:matrix.org", 5},
    {"@quadro:matrix.org", 6},
    {"@tcll:matrix.org", 7},
    {"@eeetile:matrix.org", 8},
    {"@etile:matrix.org", 8},
    {"@tranquillity_:midov.pl", 9},
    {"@troler:asra.gr", 10},
    {"@xnq:matrix.org", 11},
    {"@jacobtech-bot:matrix.org", 12}
};

List<Tuple<string, byte[], PictureType, byte[]>> BMapL = new()
{
    new("Rqndomnezz", File.ReadAllBytes("/home/jacob/Downloads/2023-01-20_23-29.png"), PictureType.png, new byte[] { 161, 196, 248, 255 }),
    new("ardillybar", File.ReadAllBytes("/home/jacob/Downloads/a.jpeg"), PictureType.jpeg, new byte[] { 255, 168, 188, 255 }),
    new("Cats", File.ReadAllBytes("/home/jacob/Downloads/c.png"), PictureType.png, new byte[] { 114, 213, 174, 255 }),
    new("jobotnik", File.ReadAllBytes("/home/jacob/Downloads/j.png"), PictureType.png, new byte[] { 161, 196, 248, 255 }),
    new("Kyron Saif", File.ReadAllBytes("/home/jacob/Downloads/k.png"), PictureType.png, new byte[] { 114, 213, 174, 255 }),
    new("Lucky Black", File.ReadAllBytes("/home/jacob/Downloads/b.png"), PictureType.png, new byte[] { 161, 196, 248, 255 }),
    new("quadro", Array.Empty<byte>(), PictureType.none, new byte[] { 229, 177, 233, 255  }),
    new("DarkPikachu", File.ReadAllBytes("/home/jacob/Downloads/tc.png"), PictureType.png, new byte[] { 181, 132, 95, 255 }),
    new("etile", Array.Empty<byte>(), PictureType.none, new byte[] { 181, 132, 95, 255 }),
    new("tranquillity", Array.Empty<byte>(), PictureType.none, new byte[] { 161, 196, 248, 255 }),
    new("Troler", File.ReadAllBytes("/home/jacob/Downloads/tr.png"), PictureType.png, new byte[] { 161, 196, 248, 255 }),
    new("xnq", File.ReadAllBytes("/home/jacob/Downloads/x.png"), PictureType.png, new byte[] { 161, 196, 248, 255 }),
    new("JacobTech Bot", Array.Empty<byte>(), PictureType.none, new byte[] { 114, 213, 174, 255 })
};
*/

//
//Matrix.ZipJsonChatExport(File.OpenRead("/run/media/jacob/F69D-7CBA/Matrix Keys/l.zip"), 0, AMap, BMap, BMapL, new(), EncoderType.UTF16, 0);
//Matrix.ZipJsonChatExport(File.OpenRead("/home/jacob/Downloads/matrix - Luski Project Discussion - Chat Export - 2023-08-08T20-10-12.315Z.zip"), 0, AMap, BMap, BMapL, new(), EncoderType.UTF16, 0);
//
//Tables.Channels.Update(Channels.ID, 0, ">=", Channels.Color.CreateDefaultParameter());
//Tables.Categories.Update(Categories.ID, 0, ">=", Categories.Color.CreateDefaultParameter());

//Console.WriteLine(Convert.ToHexString(Tables.Channels.Read(Channels.Color, Channels.ID.CreateParameter(3))));

if (!Tables.Server.TryRead(Server.ID, out _, Server.ID.CreateParameter(0)))
{
    Tables.Server.Insert();
}
//Tables.Server.Update(Server.ID, 0, Server.Picture.CreateParameter(File.ReadAllBytes("/home/jacob/Downloads/XBsECOXDZIXMVIxxMNxRfGRo.png")));
//Tables.Channels.Update(Channels.ID, 1, Channels.PictureType.CreateParameter(PictureType.png), Channels.Picture.CreateParameter(File.ReadAllBytes("/home/jacob/Downloads/zLqHooejmsmKzuMLneUSvjRH.png")));
/*
Tables.Channels.Insert(
    Channels.ID.CreateParameter(1),
    Channels.Parent.CreateParameter(0),
    Channels.Type.CreateParameter(ChannelType.TextAndVoice),
    Channels.Description.CreateParameter(Encoding.UTF8.GetBytes("A nother test Chat")),
    Channels.Name.CreateParameter(Encoding.UTF8.GetBytes("Chat 1")),
    Channels.RoleOverides.CreateParameter(Array.Empty<long>()),
    Channels.UserOverides.CreateParameter(Array.Empty<long>()),
    Channels.Epoch.CreateParameter(DateTime.UtcNow.Date),
    Channels.TitleEncryptionKey.CreateParameter(0),
    Channels.DescriptionEncryptionKey.CreateParameter(0),
    Channels.EncryptionKeys.CreateParameter(new long[]{0}),
    Channels.TitleEncoderType.CreateParameter(EncoderType.UTF8),
    Channels.DescriptionEncoderType.CreateParameter(EncoderType.UTF8),
    Channels.PictureType.CreateParameter(PictureType.png),
    Channels.Picture.CreateParameter(File.ReadAllBytes("/home/jacob/Downloads/4ba.png")),
    Channels.EncoderTypes.CreateParameter(new [] { EncoderType.UTF8 }));
Tables.Channels.Insert(
    Channels.ID.CreateParameter(2),
    Channels.Parent.CreateParameter(1),
    Channels.Type.CreateParameter(ChannelType.TextAndVoice),
    Channels.Description.CreateParameter(Encoding.UTF8.GetBytes("A nother test Chat")),
    Channels.Name.CreateParameter(Encoding.UTF8.GetBytes("Chat 2")),
    Channels.RoleOverides.CreateParameter(Array.Empty<long>()),
    Channels.UserOverides.CreateParameter(Array.Empty<long>()),
    Channels.Epoch.CreateParameter(DateTime.UtcNow.Date),
    Channels.TitleEncryptionKey.CreateParameter(0),
    Channels.DescriptionEncryptionKey.CreateParameter(0),
    Channels.EncryptionKeys.CreateParameter(new long[]{0}),
    Channels.TitleEncoderType.CreateParameter(EncoderType.UTF8),
    Channels.DescriptionEncoderType.CreateParameter(EncoderType.UTF8),
    Channels.PictureType.CreateParameter(PictureType.png),
    Channels.Picture.CreateParameter(File.ReadAllBytes("/home/jacob/Downloads/4ba.png")),
    Channels.EncoderTypes.CreateParameter(new [] { EncoderType.UTF8 }));
Tables.Channels.Insert(
    Channels.ID.CreateParameter(3),
    Channels.Parent.CreateParameter(2),
    Channels.Type.CreateParameter(ChannelType.TextAndVoice),
    Channels.Description.CreateParameter(Encoding.UTF8.GetBytes("A nother test Chat")),
    Channels.Name.CreateParameter(Encoding.UTF8.GetBytes("Chat 3")),
    Channels.RoleOverides.CreateParameter(Array.Empty<long>()),
    Channels.UserOverides.CreateParameter(Array.Empty<long>()),
    Channels.Epoch.CreateParameter(DateTime.UtcNow.Date),
    Channels.TitleEncryptionKey.CreateParameter(0),
    Channels.DescriptionEncryptionKey.CreateParameter(0),
    Channels.EncryptionKeys.CreateParameter(new long[]{0}),
    Channels.TitleEncoderType.CreateParameter(EncoderType.UTF8),
    Channels.DescriptionEncoderType.CreateParameter(EncoderType.UTF8),
    Channels.PictureType.CreateParameter(PictureType.png),
    Channels.Picture.CreateParameter(File.ReadAllBytes("/home/jacob/Downloads/4ba.png")),
    Channels.EncoderTypes.CreateParameter(new [] { EncoderType.UTF8 }));
Tables.Categories.Insert(
    Categories.ID.CreateParameter(1),
    Categories.Name.CreateParameter(Encoding.UTF8.GetBytes("Cat lol")),
    Categories.Parent.CreateParameter(0),
    Categories.Description.CreateParameter(
        Encoding.UTF8.GetBytes("Test cat")),
    Categories.RoleOverides.CreateParameter(Array.Empty<long>())
);
Tables.Categories.Insert(
    Categories.ID.CreateParameter(2),
    Categories.Name.CreateParameter(Encoding.UTF8.GetBytes("Cat lol")),
    Categories.Parent.CreateParameter(1),
    Categories.Description.CreateParameter(
        Encoding.UTF8.GetBytes("Test cat")),
    Categories.RoleOverides.CreateParameter(Array.Empty<long>())
);
*/
if (!LuskiFunctions.Database.VersionsTable.TryRead(LuskiFunctions.Database.VersionsTable.ID, out _,
        LuskiFunctions.Database.VersionsTable.ID.CreateParameter(0)))
{
    LuskiFunctions.Database.VersionsTable.Insert(LuskiFunctions.Database.VersionsTable.ID.CreateParameter(0));
}

//Tables.Roles.Update(Roles.ID, 1, Roles.Color.CreateParameter(new byte[]{1,143,243,255}));

/*
Tables.Roles.Insert(
    Roles.ID.CreateParameter(1),
    Roles.Name.CreateParameter("Mod"),
    Roles.DisplayName.CreateParameter("Moderators"),
    Roles.Color.CreateDefaultParameter(),
    Roles.Description.CreateParameter("Mods for the server"),
    Roles.ServerPermission.CreateParameter(new[]
    {
        ServerPermission.ViewChannels,
        ServerPermission.ViewCategories,
        ServerPermission.Nickname,
        ServerPermission.SendMessages,
        ServerPermission.SendFiles,
        ServerPermission.ChannelPings,
        ServerPermission.ServerPings,
        ServerPermission.PingSomeone,
        ServerPermission.ReadMessageHistory,
        ServerPermission.UseServerCommands,
        ServerPermission.JoinVoice,
        ServerPermission.SpeakInVoice,
        ServerPermission.ViewThis,
        ServerPermission.Kick,
        ServerPermission.CreateCategories,
        ServerPermission.CreateChannels,
        ServerPermission.DeleteCategories,
        ServerPermission.DeleteChannels,
        ServerPermission.EditCategories,
        ServerPermission.EditChannels,
        ServerPermission.EditCategoryPermissions,
        ServerPermission.EditChannelPermissions,
        ServerPermission.Invite,
        ServerPermission.ManageMessages,
        ServerPermission.ManageRoles,
        ServerPermission.ViewLogs
    })
);
*/

if (!Tables.Roles.TryRead(Roles.ID, out _, Roles.ID.CreateParameter(0)))
{
    Tables.Roles.Insert(
        Roles.ID.CreateParameter(0),
        Roles.Name.CreateParameter("server"),
        Roles.DisplayName.CreateParameter("Members"),
        Roles.Color.CreateDefaultParameter(),
        Roles.Description.CreateParameter("The default role for the server. Everybody will have this role."),
        Roles.ServerPermissions.CreateParameter(
            ServerPermission.ViewChannels |
            ServerPermission.ViewCategories |
            ServerPermission.Nickname |
            ServerPermission.SendMessages |
            ServerPermission.SendFiles |
            ServerPermission.ChannelPings |
            ServerPermission.ServerPings |
            ServerPermission.PingSomeone |
            ServerPermission.ReadMessageHistory |
            ServerPermission.UseServerCommands |
            ServerPermission.JoinVoice |
            ServerPermission.SpeakInVoice |
            ServerPermission.ViewThis)
    );
}

if (!Tables.Keys.TryRead(Keys.ID, out _, Keys.ID.CreateParameter(0)))
{
    Tables.Keys.Insert(
        Keys.ID.CreateParameter(0),
        Keys.EncryptionType.CreateParameter(EncryptionType.None),
        Keys.KeyData.CreateParameter(Array.Empty<byte>()));
}

if (!Tables.Categories.TryRead(Categories.ID, out _, Categories.ID.CreateParameter(0)))
{
    Tables.Categories.Insert(
        Categories.ID.CreateParameter(0),
        Categories.Name.CreateParameter(Encoding.UTF8.GetBytes("server")),
        Categories.Parent.CreateParameter(-1),
        Categories.Channels.CreateParameter(new long[]{0}),
        Categories.Description.CreateParameter(
            Encoding.UTF8.GetBytes("The default category for the server. Everybody will see this category.")),
        Categories.RoleOverrides.CreateParameter(Array.Empty<long>())
    );
    Tables.Channels.Insert(
        Channels.ID.CreateParameter(0),
        Channels.Type.CreateParameter(ChannelType.TextAndVoice),
        Channels.Description.CreateParameter(Encoding.UTF8.GetBytes("Default chat for you to use in your new server")),
        Channels.Name.CreateParameter(Encoding.UTF8.GetBytes("Default Channel")),
        Channels.RoleOverrides.CreateParameter(Array.Empty<long>()),
        Channels.UserOverrides.CreateParameter(Array.Empty<long>()),
        Channels.Epoch.CreateParameter(DateTime.UtcNow.Date),
        Channels.TitleEncryptionKey.CreateParameter(0),
        Channels.Parent.CreateParameter(0),
        Channels.DescriptionEncryptionKey.CreateParameter(0),
        Channels.EncryptionKeys.CreateParameter(new long[]{0}),
        Channels.TitleEncoderType.CreateParameter(EncoderType.UTF8),
        Channels.DescriptionEncoderType.CreateParameter(EncoderType.UTF8),
        Channels.PictureType.CreateParameter(PictureType.none),
        Channels.Picture.CreateParameter(Array.Empty<byte>()),
        Channels.EncoderTypes.CreateParameter(new [] { EncoderType.UTF8 }));
}

long[] keys = Tables.Sessions.ReadColumn(Sessions.SessionKey);
foreach (long key in keys)
{
    Tables.Keys.DeleteRow(Keys.ID.CreateParameter(key));
}



Tables.Sessions.DeleteRows();


foreach (AltServerRow Server in Tables.AltServers.ReadRows())
{
    //TODO add code to open a live WSS connection with all other servers on the network
}

WSS.Init(LuskiFunctions.Config.IPv4WSS, LuskiFunctions.Config.IPv4PortWSS, LuskiFunctions.Config.IPv4_URL_WSS!, LuskiFunctions.Config.IPv4SecureWSS, LuskiFunctions.Config.IPv6WSS, LuskiFunctions.Config.IPv6_URL_WSS, LuskiFunctions.Config.IPv6PortWSS, LuskiFunctions.Config.IPv6SecureWSS);

WebApplicationBuilder builder = WebApplication.CreateBuilder( args );

// Add services to the container.

builder.Services.AddControllers();
builder.Services.AddProblemDetails();
builder.Services.AddApiVersioning(
                    options =>
                    {
                        // reporting api versions will return the headers
                        // "api-supported-versions" and "api-deprecated-versions"
                        options.ReportApiVersions = true;
                        
                        /*    Sunset example
                        options.Policies.Sunset( 1 )
                                        //.Effective( DateTimeOffset.Now.Subtract( new TimeSpan(9999999) ) )
                                        .Effective( DateTimeOffset.Now.AddDays( 2 ) )
                                        .Link( "policy.html" )
                                            .Title( "Versioning Policy" )
                                            .Type( "text/html" );
                                            */
                    } )
                .AddMvc()
                .AddApiExplorer(
                    options =>
                    {
                        // add the versioned api explorer, which also adds IApiVersionDescriptionProvider service
                        // note: the specified format code will format the version as "'v'major[.minor][-status]"
                        options.GroupNameFormat = "'v'VVV";

                        // note: this option is only necessary when versioning by url segment. the SubstitutionFormat
                        // can also be used to control the format of the API version in route templates
                        options.SubstituteApiVersionInUrl = true;
                    } );
builder.Services.Configure<ApiBehaviorOptions>(options =>
{
    options.InvalidModelStateResponseFactory = actionContext => 
    {
        string content;
        using (StreamReader reader = new(actionContext.HttpContext.Request.Body))
        {
            content = reader.ReadToEndAsync().Result;
        }

        if (string.IsNullOrEmpty(content)) return new ObjectResult(new STC()
        {
            Error = ErrorCode.MissingPostData,
            ErrorMessage = "The post information was missing"
        })
        {
            StatusCode = 403
        };
        return new ObjectResult(new STC()
        {
            Error = ErrorCode.InvalidPostData,
            ErrorMessage = "The provided post information was invalid"
        })
        {
            StatusCode = 403
        };
    };
});
// Learn more about configuring Swagger/OpenAPI at https://aka.ms/aspnetcore/swashbuckle
builder.Services.AddTransient<IConfigureOptions<SwaggerGenOptions>, ConfigureSwaggerOptions>();
builder.Services.AddSwaggerGen(
    options =>
    {
        // add a custom operation filter which sets default values
        options.OperationFilter<SwaggerDefaultValues>();

        string fileName = typeof(Program).Assembly.GetName().Name + ".xml";
        string filePath = Path.Combine(AppContext.BaseDirectory, fileName);

        // integrate xml comments
        options.IncludeXmlComments(filePath, true);
    } );

WebApplication app = builder.Build();
// Configure the HTTP request pipeline.

app.UseSwagger();
//app.UseHttpLogging();
app.UseSwaggerUI(
    options =>
    {
        IReadOnlyList<ApiVersionDescription> descriptions = app.DescribeApiVersions();

        // build a swagger endpoint for each discovered API version
        foreach ( ApiVersionDescription description in descriptions )
        {
            string url = $"/swagger/{description.GroupName}/swagger.json";
            string name = description.GroupName.ToUpperInvariant();
            options.SwaggerEndpoint(url, name);
        }
        options.InjectStylesheet("/www/css/SwaggerDark.css");
        options.DocumentTitle = "Luski Server API";
    } );
app.MapGet("/www/css/SwaggerDark.css", async (CancellationToken t) =>
{
    byte[] css = await File.ReadAllBytesAsync("www/css/SwaggerDark.css", t);
    return Results.File(css, "text/css");
}).ExcludeFromDescription();
app.UseHttpsRedirection();
app.UseAuthorization();
app.MapControllers();
app.Run();